# Force Team by Edro Wolter (deXtro)
# ./addons/eventscripts/forceteam/forceteam.py

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####       COULD BREAK      #####
#################################

""" Changes for this version
- mixed forceteam with last version of Source Python Extensions (1.5.0e)
- added say command to force alive player to spectate
- added file strings.ini for localisation
"""

# Import Modules
import es, popuplib, playerlib, services, cfglib, os, cmdlib
import weaponlib, langlib
import spe

info = es.AddonInfo()
info.author      = "Edro Wolter (deXtro)"
info.name        = "Force Team"
info.basename    = "forceteam"
info.version     = "1.0c"
info.url         = "http://addons.eventscripts.com/addons/view/%s"%info.basename
info.description = "Force the same team when player tries do respawn" 

es.ServerVar(info.basename, info.version, info.description + " made by " + info.author).makepublic()

text = lambda identifier, options = {}, lang = "en" : "No strings.ini found in ../addons/eventscripts/%(basename)s/%(basename)s.py" % {"basename" : info.basename}

""" Config """
config = cfglib.AddonCFG( os.path.join( es.getAddonPath(info.basename), "config.cfg" ) )

config.text("********************")
config.text(" ForceTeam Settings ")
config.text("********************")
config.text("../addons/eventscripts/%s/config.cfg" % info.basename )
config.text("%s Version %s by %s" % ( info.name, info.version, info.author ) )
config.text("For more info, visit: %s" % info.url)
forceteam_command = config.cvar("forceteam_command", '!forceteam' , "Force team command to use in player say")
forceteam_enable  = config.cvar("forceteam_enable", 1, "If this is enabled (1) then it force team respawn")
forcespec_command = "!forcesp"
forcespec_enable  = config.cvar("forcespec_enable", 1, "If this is enabled (1) then it force player spec")
config.write()

""" Load the languages """
langPath = os.path.join( es.getAddonPath( info.basename ), "strings.ini" )
if os.path.isfile(langPath):
   text = langlib.Strings(langPath)

def setup_auth():
   global isAuthed
   if services.isRegistered('auth'):
      auth_service = services.use('auth')
      auth_service.registerCapability('forceteam_admin', auth_service.ADMIN)
      isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'forceteam_admin')
   else:
      isAuthed = lambda x: False

def load():
   setup_auth()
   cmdlib.registerSayCommand(forceteam_command, sendPopupMenu, '')
   cmdlib.registerSayCommand(forcespec_command, forceSpec, '')
   config.execute()
   es.addons.registerClientCommandFilter(clientFilter)

def unload():
   cmdlib.unregisterSayCommand(forceteam_command)
   cmdlib.unregisterSayCommand(forcespec_command)
   es.addons.unregisterClientCommandFilter(clientFilter)
   for popup in ["forceteammenu"]:
      try: popuplib.delete(popup)
      except: pass

def clientFilter(userid, args):
   """ handles forceteam option """
   if forceteam_enable:
      if args[0].lower() == 'jointeam' and es.getplayerteam(userid) > 0:
         # Changing to same team or auto assign, respawn player without choosing class model
         if es.getplayerteam(userid) == int(args[1]) or int(args[1]) == 0:
            player = playerlib.getPlayer(userid)
            spe.respawn(userid)
            return False
   return True
   
def sendPopupMenu(userid, args):
   if isAuthed(userid):
      popupForceteam(userid)
   else:
      tell(userid, 'player not authed')

def tell(userid, message, options = {}, tellMessage = True):
   message = text(message, options, playerlib.getPlayer(userid).get("lang") )
   if tellMessage:
      es.tell(userid, '#multi', '#green[%s] #lightgreen%s' % (info.name,message))
   else:
      return message
   
def popupForceteam(userid):
   forceteammenu = popuplib.create("forceteammenu")
   forceteammenu.addline("Force Team v.%s" % info.version)
   forceteammenu.addline("-" * 30)
   if forceteam_enable==1:
      msg = "Enabled"
   else:
      msg = "Disabled"
   forceteammenu.addline("-> 1. %s" % msg)
   forceteammenu.addline("-" * 30)
   forceteammenu.addline("0. Close")
   forceteammenu.menuselect = changeOption
   forceteammenu.send(userid)
   
def changeOption(userid, choice, popupid):
   """
   Handles the menu select from the admin menu.
   """
   global forceteam_enable
   if choice == 1:
      if forceteam_enable:
         forceteam_enable = 0
      else:
         forceteam_enable = 1
      popupForceteam(userid)

def forceSpec(userid, args):
   if es.getplayercount() >= es.getmaxplayercount():
      tell(userid, 'max players reached')
   else:
      player = playerlib.getPlayer(userid)
      if player:
         if not player.isobserver and not player.isdead:
            # Remove player weapons
            weaponlist = player.getWeaponList()
            stripPlayer(userid,player.getWeaponList())

            # Player spectate
            es.changeteam(userid,1)
      else:
         tell(userid, 'player not found')

def stripPlayer(userid, remove=None, keep=None):
   weaponlist = set(playerlib.getPlayer(userid).getWeaponList())
 
   if not remove is None:
      if not hasattr(remove, '__iter__'):
         remove = (remove,)
      weaponlist = weaponlist.intersection(map(weaponlib.getWeapon, remove))
      
   if not hasattr(keep, '__iter__'):
      keep = (keep,)
 
   weaponlist = weaponlist.difference(map(weaponlib.getWeapon, keep))
 
   handle = es.getplayerhandle(userid)
 
   for weapon in weaponlist:
      for index in weapon.indexlist:
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
            es.server.queuecmd('es_xremove %s' % index)
            continue
